#pragma once

#include <string_view>
#include <boost/spirit/home/x3/support/ast/variant.hpp>
#include <map>
#include <vector>
#include <array>
#include <cstdint>

namespace duck {
typedef std::string_view TorrentStringType;
typedef signed long long int TorrentIntType;

struct TorrentValue : public boost::spirit::x3::variant<
	TorrentIntType,
	TorrentStringType,
	boost::spirit::x3::forward_ast< std::vector<TorrentValue> >,
	boost::spirit::x3::forward_ast< std::map<TorrentStringType, TorrentValue> >
> {
	using base_type::base_type;
	using base_type::operator=;
};

std::vector<TorrentValue> parse_torrent (std::string_view binary_data);
std::vector<std::array<std::uint32_t, 5>> collect_hashes (std::string_view hashes);
std::vector<std::array<std::uint32_t, 5>> collect_hashes (const std::vector<TorrentValue>& values);
} //namespace duck
