#pragma once

#include "../parser.hpp"

#include <cstddef>

namespace duck {
class DebugVisitor {
public:
	DebugVisitor(int depth=0, bool skip_first=true);

	void reset();
	void operator() (TorrentIntType value);
	void operator() (const TorrentStringType& value);
	void operator() (const std::vector<duck::TorrentValue>& value);
	void operator() (const std::map<duck::TorrentStringType, duck::TorrentValue>& value);

private:
	void print_tabs(int extra=0);

	int m_depth;
	bool m_first_line;
	bool m_skip_first;
};
} //namespace duck
